Package org.bukkit.event.entity

# Class ProjectileHitEvent

java.lang.Object
org.bukkit.event.Event
org.bukkit.event.entity.EntityEvent
org.bukkit.event.entity.ProjectileHitEvent

All Implemented Interfaces:
  `Cancellable`

Direct Known Subclasses:
  `ExpBottleEvent`, `LingeringPotionSplashEvent`, `PotionSplashEvent`, `TargetHitEvent`

public class ProjectileHitEvent extends EntityEvent implements Cancellable
Called when a projectile hits an object

## Nested Class Summary

## Nested classes/interfaces inherited from class org.bukkit.event.Event

`Event.Result`

## Field Summary

### Fields inherited from class org.bukkit.event.entity.EntityEvent

`entity`

## Constructor Summary

Constructors
Constructor
Description
`ProjectileHitEvent(@NotNull Projectile projectile)`
`ProjectileHitEvent(@NotNull Projectile projectile, @Nullable Block hitBlock)`
`ProjectileHitEvent(@NotNull Projectile projectile, @Nullable Entity hitEntity)`
`ProjectileHitEvent(@NotNull Projectile projectile, @Nullable Entity hitEntity, @Nullable Block hitBlock)`
`ProjectileHitEvent(@NotNull Projectile projectile, @Nullable Entity hitEntity, @Nullable Block hitBlock, @Nullable BlockFace hitFace)`

## Method Summary

Modifier and Type
Method
Description
`@NotNull Projectile`
`getEntity()`
Returns the Entity involved in this event
`static @NotNull HandlerList`
`getHandlerList()`
`@NotNull HandlerList`
`getHandlers()`
`@Nullable Block`
`getHitBlock()`
Gets the block that was hit, if it was a block that was hit.
`@Nullable BlockFace`
`getHitBlockFace()`
Gets the block face that was hit, if it was a block that was hit and the face was provided in the vent.
`@Nullable Entity`
`getHitEntity()`
Gets the entity that was hit, if it was an entity that was hit.
`boolean`
`isCancelled()`
Gets the cancellation state of this event.
`void`
`setCancelled(boolean cancel)`
Whether to cancel the action that occurs when the projectile hits.

### Methods inherited from class org.bukkit.event.entity.EntityEvent

`getEntityType`

### Methods inherited from class org.bukkit.event.Event

`callEvent, getEventName, isAsynchronous`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### ProjectileHitEvent

public ProjectileHitEvent(@NotNull @NotNull Projectile projectile)

### ProjectileHitEvent

public ProjectileHitEvent(@NotNull @NotNull Projectile projectile, @Nullable @Nullable Entity hitEntity)

### ProjectileHitEvent

public ProjectileHitEvent(@NotNull @NotNull Projectile projectile, @Nullable @Nullable Block hitBlock)

### ProjectileHitEvent

public ProjectileHitEvent(@NotNull @NotNull Projectile projectile, @Nullable @Nullable Entity hitEntity, @Nullable @Nullable Block hitBlock)

### ProjectileHitEvent

public ProjectileHitEvent(@NotNull @NotNull Projectile projectile, @Nullable @Nullable Entity hitEntity, @Nullable @Nullable Block hitBlock, @Nullable @Nullable BlockFace hitFace)

## Method Details

### getEntity

@NotNull public @NotNull Projectile getEntity()
Description copied from class: `EntityEvent`
Returns the Entity involved in this event

Overrides:
  `getEntity` in class `EntityEvent`
Returns:
  Entity who is involved in this event

### getHitBlock

@Nullable public @Nullable Block getHitBlock()
Gets the block that was hit, if it was a block that was hit.

Returns:
  hit block or else null

### getHitBlockFace

@Nullable public @Nullable BlockFace getHitBlockFace()
Gets the block face that was hit, if it was a block that was hit and the face was provided in the vent.

Returns:
  hit face or else null

### getHitEntity

@Nullable public @Nullable Entity getHitEntity()
Gets the entity that was hit, if it was an entity that was hit.

Returns:
  hit entity or else null

### isCancelled

public boolean isCancelled()
Description copied from interface: `Cancellable`
Gets the cancellation state of this event. A cancelled event will not be executed in the server, but will still pass to other plugins

Specified by:
  `isCancelled` in interface `Cancellable`
Returns:
  true if this event is cancelled

### setCancelled

public void setCancelled(boolean cancel)
Whether to cancel the action that occurs when the projectile hits. In the case of an entity, it will not collide (unless it's a firework, then use `FireworkExplodeEvent`).
In the case of a block, some blocks (eg target block, bell) will not perform the action associated.
This does NOT prevent block collisions, and explosions will still occur unless their respective events are cancelled.

Specified by:
  `setCancelled` in interface `Cancellable`
Parameters:
  `cancel` - true if you wish to cancel this event

### getHandlers

@NotNull public @NotNull HandlerList getHandlers()

Specified by:
  `getHandlers` in class `Event`

### getHandlerList

@NotNull public static @NotNull HandlerList getHandlerList()